﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			this.DataContext = new Person() { FirstName = "Nencho", LastName = "Nenkov", Email = "nn@workmail.com" };
		}

		private void CommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
		{
			Print();
		}

		private void radMenu1_ItemClick(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			Print();
		}

		private void Print()
		{
			this.Dispatcher.BeginInvoke(new Action(() =>
				{
					TextBox textBox = Keyboard.FocusedElement as TextBox;
					if (textBox != null)
					{
						BindingExpression expression = textBox.GetBindingExpression(TextBox.TextProperty);
						if (expression != null)
						{
							expression.UpdateSource();
						}
					}

					MessageBox.Show("Passed\n" +
							((Person)this.DataContext).FirstName + "\n" +
							((Person)this.DataContext).LastName + "\n" +
							((Person)this.DataContext).Email);
				}));
		}
	}

	public class Person : INotifyPropertyChanged
	{
		private string firstName;
		private string email;
		private string lastName;

		public string FirstName
		{
			get { return firstName; }
			set
			{
				if (firstName != value)
				{
					firstName = value;
					this.OnPropertyChanged("FirstName");
				}
			}
		}


		public string LastName
		{
			get { return lastName; }
			set
			{
				if (lastName != value)
				{
					lastName = value;
					this.OnPropertyChanged("LastName");
				}
			}
		}


		public string Email
		{
			get { return email; }
			set
			{
				if (email != value)
				{
					email = value;
					this.OnPropertyChanged("Email");
				}
			}
		}


		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string name)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(name));
			}
		}
	}
}
